"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Has = void 0;
var HasExternalOneToMany_1 = require("./external/HasExternalOneToMany");
var HasExternalOneToOne_1 = require("./external/HasExternalOneToOne");
var HasManyToMany_1 = require("./internal/HasManyToMany");
var HasOneToMany_1 = require("./internal/HasOneToMany");
var HasOneToOne_1 = require("./internal/HasOneToOne");
/**
 * Decorators for the "has" relationship.
 *
 * `Has` is a module containing decorators who can represent the "has" relationship.
 *
 * @author Jeongho Nam - https://github.com/samchon
 */
var Has;
(function (Has) {
    Has.OneToOne = HasOneToOne_1.HasOneToOne;
    Has.OneToMany = HasOneToMany_1.HasOneToMany;
    Has.ManyToMany = HasManyToMany_1.HasManyToMany;
    var External;
    (function (External) {
        External.OneToOne = HasExternalOneToOne_1.HasExternalOneToOne;
        External.OneToMany = HasExternalOneToMany_1.HasExternalOneToMany;
    })(External = Has.External || (Has.External = {}));
})(Has = exports.Has || (exports.Has = {}));
//# sourceMappingURL=Has.js.map