"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BelongsExternalManyToOne = void 0;
var DomainError_1 = require("tstl/exception/DomainError");
var OutOfRange_1 = require("tstl/exception/OutOfRange");
var MutableSingleton_1 = require("tstl/thread/MutableSingleton");
var Singleton_1 = require("tstl/thread/Singleton");
var orm = __importStar(require("typeorm"));
var findRepository_1 = require("../../functional/findRepository");
var BelongsAccessorBase_1 = require("../base/BelongsAccessorBase");
var ClosureProxy_1 = require("../base/ClosureProxy");
var ReflectAdaptor_1 = require("../base/ReflectAdaptor");
var RelationshipVariable_1 = require("../base/RelationshipVariable");
var get_primary_field_1 = require("../base/get_primary_field");
var take_index_option_1 = require("../base/take_index_option");
function BelongsExternalManyToOne(target) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    // LIST UP PARAMETERS
    var inverse = typeof args[0] === "function" ? args.splice(0, 1)[0] : undefined;
    var type = args[0];
    var foreign_key_field = args[1];
    var options = args[2] || {};
    return function ($class, $property) {
        // DECORATOR
        orm.Column(type, (0, take_index_option_1.take_index_option)(options))($class, foreign_key_field);
        if (options.index === true)
            orm.Index()($class, foreign_key_field);
        // METADATA
        var metadata = {
            type: "Belongs.External.ManyToOne",
            target: target,
            inverse: inverse !== undefined ? ClosureProxy_1.ClosureProxy.steal(inverse) : null,
            property: $property,
            foreign_key_field: foreign_key_field,
            target_priamary_field: new Singleton_1.Singleton(function () {
                return (0, get_primary_field_1.get_primary_field)(target());
            }),
            nullable: !!options.nullable,
        };
        ReflectAdaptor_1.ReflectAdaptor.set($class, $property, metadata);
        // ACCESSOR
        var label = RelationshipVariable_1.RelationshipVariable.helper("belongs", $property);
        Object.defineProperty($class, $property, {
            get: function () {
                if (this[label] === undefined)
                    this[label] = BelongsExternalManyToOne.Accessor.create(metadata, this);
                return this[label];
            },
        });
    };
}
exports.BelongsExternalManyToOne = BelongsExternalManyToOne;
(function (BelongsExternalManyToOne) {
    var Accessor = /** @class */ (function (_super) {
        __extends(Accessor, _super);
        function Accessor(metadata_, mine_) {
            var _this = _super.call(this) || this;
            _this.metadata_ = metadata_;
            _this.mine_ = mine_;
            _this.singleton_ = new MutableSingleton_1.MutableSingleton(function () { return _this._Get(); });
            return _this;
        }
        /**
         * @internal
         */
        Accessor.create = function (metadata, mine) {
            return new Accessor(metadata, mine);
        };
        Object.defineProperty(Accessor.prototype, "id", {
            get: function () {
                return this.mine_[this.metadata_.foreign_key_field];
            },
            set: function (value) {
                var _this = this;
                if (value === this.id)
                    return;
                this.mine_[this.metadata_.foreign_key_field] = value;
                this.singleton_ = new MutableSingleton_1.MutableSingleton(function () { return _this._Get(); });
            },
            enumerable: false,
            configurable: true
        });
        Accessor.prototype.set = function (obj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (obj === null && this.metadata_.nullable === false)
                                throw new DomainError_1.DomainError(this.get_null_error_message("set()"));
                            return [4 /*yield*/, this.singleton_.set(obj)];
                        case 1:
                            _a.sent();
                            this.mine_[this.metadata_.foreign_key_field] =
                                obj !== null
                                    ? obj[this.metadata_.target_priamary_field.get()]
                                    : null;
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @internal
         */
        Accessor.prototype._Assign = function (obj) {
            // VALIDATION
            if (obj === null && this.metadata_.nullable === false)
                throw new DomainError_1.DomainError(this.get_null_error_message("initialize()"));
            // ENFORCED ASSIGNMENTS
            this.singleton_["value_"] = obj;
            this.mine_[this.metadata_.foreign_key_field] =
                obj !== null
                    ? obj[this.metadata_.target_priamary_field.get()]
                    : null;
        };
        Accessor.prototype.reload = function () {
            return this.singleton_.reload();
        };
        Accessor.prototype.get = function () {
            return this.singleton_.get();
        };
        Accessor.prototype._Get = function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, output;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = this.mine_[this.metadata_.foreign_key_field];
                            return [4 /*yield*/, (0, findRepository_1.findRepository)(this.metadata_.target()).findOne(id)];
                        case 1:
                            output = _a.sent();
                            if (output === undefined)
                                if (this.metadata_.nullable === false)
                                    throw new OutOfRange_1.OutOfRange(this.get_null_error_message("get()"));
                                else
                                    return [2 /*return*/, null];
                            return [2 /*return*/, output];
                    }
                });
            });
        };
        Accessor.prototype.get_null_error_message = function (symbol) {
            return "Error on ".concat(this.mine_.constructor.name, ".").concat(this.metadata_.property, ".").concat(symbol, ": must not be null");
        };
        return Accessor;
    }(BelongsAccessorBase_1.BelongsAccessorBase));
    BelongsExternalManyToOne.Accessor = Accessor;
})(BelongsExternalManyToOne = exports.BelongsExternalManyToOne || (exports.BelongsExternalManyToOne = {}));
//# sourceMappingURL=BelongsExternalManyToOne.js.map