"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HasExternalOneToMany = void 0;
var MutableSingleton_1 = require("tstl/thread/MutableSingleton");
var Singleton_1 = require("tstl/thread/Singleton");
var findRepository_1 = require("../../functional/findRepository");
var getColumn_1 = require("../../functional/getColumn");
var ClosureProxy_1 = require("../base/ClosureProxy");
var ReflectAdaptor_1 = require("../base/ReflectAdaptor");
var RelationshipVariable_1 = require("../base/RelationshipVariable");
var get_primary_field_1 = require("../base/get_primary_field");
function HasExternalOneToMany(target, inverse, comparator) {
    return function ($class, $property) {
        // LIST UP PROPERTIES
        var label = RelationshipVariable_1.RelationshipVariable.helper("has", $property);
        var inverse_property = ClosureProxy_1.ClosureProxy.steal(inverse);
        var foreign_key_field = new Singleton_1.Singleton(function () {
            return (0, getColumn_1.getColumn)(target(), ".".concat(inverse_property), null);
        });
        var primary_field = new Singleton_1.Singleton(function () {
            return (0, get_primary_field_1.get_primary_field)($class.constructor);
        });
        // METADATA
        var metadata = {
            type: "Has.External.OneToMany",
            target: target,
            inverse: inverse_property,
            property: $property,
            primary_field: primary_field,
            foreign_key_field: foreign_key_field,
            comparator: comparator,
        };
        ReflectAdaptor_1.ReflectAdaptor.set($class, $property, metadata);
        // ACCESSOR
        Object.defineProperty($class, $property, {
            get: function () {
                if (this[label] === undefined)
                    this[label] = HasExternalOneToMany.Accessor.create(metadata, this);
                return this[label];
            },
        });
    };
}
exports.HasExternalOneToMany = HasExternalOneToMany;
(function (HasExternalOneToMany) {
    var Accessor = /** @class */ (function () {
        function Accessor(metadata_, mine_) {
            var _this = this;
            this.metadata_ = metadata_;
            this.mine_ = mine_;
            this.singleton_ = new MutableSingleton_1.MutableSingleton(function () { return _this._Get(); });
        }
        /**
         * @internal
         */
        Accessor.create = function (metadata, mine) {
            return new Accessor(metadata, mine);
        };
        Accessor.prototype.set = function (objs) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this.metadata_.comparator)
                                objs = objs.sort(this.metadata_.comparator);
                            return [4 /*yield*/, this.singleton_.set(objs)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        Accessor.prototype.get = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.singleton_.get()];
                });
            });
        };
        Accessor.prototype._Get = function () {
            return __awaiter(this, void 0, void 0, function () {
                var primary, foreign, data, data_1, data_1_1, elem, e_1_1;
                var _a, e_1, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            primary = this.metadata_.primary_field.get();
                            foreign = this.metadata_.foreign_key_field.get();
                            return [4 /*yield*/, (0, findRepository_1.findRepository)(this.metadata_.target()).find((_a = {}, _a[foreign] = this.mine_[primary], _a))];
                        case 1:
                            data = _c.sent();
                            _c.label = 2;
                        case 2:
                            _c.trys.push([2, 7, 8, 9]);
                            data_1 = __values(data), data_1_1 = data_1.next();
                            _c.label = 3;
                        case 3:
                            if (!!data_1_1.done) return [3 /*break*/, 6];
                            elem = data_1_1.value;
                            return [4 /*yield*/, elem[this.metadata_.inverse].set(this.mine_)];
                        case 4:
                            _c.sent();
                            _c.label = 5;
                        case 5:
                            data_1_1 = data_1.next();
                            return [3 /*break*/, 3];
                        case 6: return [3 /*break*/, 9];
                        case 7:
                            e_1_1 = _c.sent();
                            e_1 = { error: e_1_1 };
                            return [3 /*break*/, 9];
                        case 8:
                            try {
                                if (data_1_1 && !data_1_1.done && (_b = data_1.return)) _b.call(data_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                            return [7 /*endfinally*/];
                        case 9: return [2 /*return*/, this.metadata_.comparator
                                ? data.sort(this.metadata_.comparator)
                                : data];
                    }
                });
            });
        };
        return Accessor;
    }());
    HasExternalOneToMany.Accessor = Accessor;
})(HasExternalOneToMany = exports.HasExternalOneToMany || (exports.HasExternalOneToMany = {}));
//# sourceMappingURL=HasExternalOneToMany.js.map