"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HasManyToMany = void 0;
var MutableSingleton_1 = require("tstl/thread/MutableSingleton");
var Singleton_1 = require("tstl/thread/Singleton");
var findRepository_1 = require("../../functional/findRepository");
var ArrayUtil_1 = require("../../utils/ArrayUtil");
var ClosureProxy_1 = require("../base/ClosureProxy");
var ReflectAdaptor_1 = require("../base/ReflectAdaptor");
var RelationshipVariable_1 = require("../base/RelationshipVariable");
var get_primary_field_1 = require("../base/get_primary_field");
/**
 * Decorator function for the "N:N has" relationship.
 *
 * @template Mine Type of this model class who is using it, the `Has.ManyToMany` decorator
 * @template Target Type of the target model class, who has the N: N relationship with this
 *                  model class *Mine*, through the *Route* model class
 * @template Router Type of the router model who intermediates those *Mine* and *Route* model
 *                  classes to resolve the N: N relationship
 * @param target A closure function returning the *Target* model class, who has the N: N
 *                  relationship with this model class *Mine* through the *Route* model class
 * @param router A closure function returning the *Router* model class, who intermediates
 *                  those *Mine* and *Route* model classes to resolve the N: N relationship
 * @param targetInverse A closure function returning the {@link Belongs.ManyToOne} typed member
 *                      variable, who is pointing this model class *Mine*, from the *Route*
 *                      model class
 * @param myInverse A closure function returning the {@link Belongs.ManyToOne} typed member
 *                  variable, who is poining the target model class *Target*, from the *Rote*
 *                  mode class
 * @param comparator Comparator for sorting if required.
 * @return The *PropertyDecorator* function
 */
function HasManyToMany(target, router, targetInverse, myInverse, comparator) {
    return function ($class, $property) {
        var label = RelationshipVariable_1.RelationshipVariable.helper("has", $property);
        var target_inverse = ClosureProxy_1.ClosureProxy.steal(targetInverse);
        var my_inverse = ClosureProxy_1.ClosureProxy.steal(myInverse);
        var metadata = {
            type: "Has.ManyToMany",
            target: target,
            router: router,
            target_inverse: target_inverse,
            my_inverse: my_inverse,
            my_primary_field: new Singleton_1.Singleton(function () {
                return (0, get_primary_field_1.get_primary_field)($class.constructor);
            }),
            target_primary_field: new Singleton_1.Singleton(function () {
                return (0, get_primary_field_1.get_primary_field)(target());
            }),
            router_to_my_field: new Singleton_1.Singleton(function () {
                return ReflectAdaptor_1.ReflectAdaptor.get(router().prototype, my_inverse).foreign_key_field;
            }),
            router_to_target_field: new Singleton_1.Singleton(function () {
                return ReflectAdaptor_1.ReflectAdaptor.get(router().prototype, target_inverse).foreign_key_field;
            }),
            comparator: comparator,
        };
        ReflectAdaptor_1.ReflectAdaptor.set($class, $property, metadata);
        Object.defineProperty($class, $property, {
            get: function () {
                if (this[label] === undefined)
                    this[label] = HasManyToMany.Accessor.create(metadata, this);
                return this[label];
            },
        });
    };
}
exports.HasManyToMany = HasManyToMany;
(function (HasManyToMany) {
    var Accessor = /** @class */ (function () {
        function Accessor(metadata_, mine_) {
            var _this = this;
            this.metadata_ = metadata_;
            this.mine_ = mine_;
            this.data_ = new MutableSingleton_1.MutableSingleton(function () { return _this._Get(); });
        }
        /**
         * @internal
         */
        Accessor.create = function (metadata, mine) {
            return new Accessor(metadata, mine);
        };
        Accessor.prototype.get = function () {
            return this.data_.get();
        };
        Accessor.prototype.set = function (value) {
            return this.data_.set(value);
        };
        Accessor.prototype.statement = function (joinAndSelect) {
            if (joinAndSelect === void 0) { joinAndSelect = false; }
            var router = this.metadata_.router();
            var target = this.metadata_.target();
            var joinArguments = [
                target,
                target.name,
                "".concat(target.name, ".").concat(this.metadata_.target_primary_field.get(), " = ").concat(router.name, ".").concat(this.metadata_.router_to_target_field.get()),
            ];
            var stmt = (0, findRepository_1.findRepository)(router)
                .createQueryBuilder(router.name)
                .andWhere("".concat(router.name, ".").concat(this.metadata_.router_to_my_field.get(), " = :my_id"), {
                my_id: this.mine_[this.metadata_.my_primary_field.get()],
            });
            if (joinAndSelect === true)
                stmt.innerJoinAndSelect.apply(stmt, __spreadArray([], __read(joinArguments), false));
            else
                stmt.innerJoin.apply(stmt, __spreadArray([], __read(joinArguments), false));
            return stmt;
        };
        Accessor.prototype._Get = function () {
            return __awaiter(this, void 0, void 0, function () {
                var routerList, tuples;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.statement(true).getMany()];
                        case 1:
                            routerList = _a.sent();
                            return [4 /*yield*/, ArrayUtil_1.ArrayUtil.asyncMap(routerList, function (router) { return __awaiter(_this, void 0, void 0, function () {
                                    var _a;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                _a = {
                                                    router: router
                                                };
                                                return [4 /*yield*/, router[this.metadata_.target_inverse].get()];
                                            case 1: return [2 /*return*/, (_a.target = _b.sent(),
                                                    _a)];
                                        }
                                    });
                                }); })];
                        case 2:
                            tuples = _a.sent();
                            if (this.metadata_.comparator)
                                tuples.sort(this.metadata_.comparator);
                            return [2 /*return*/, tuples.map(function (_a) {
                                    var target = _a.target;
                                    return target;
                                })];
                    }
                });
            });
        };
        return Accessor;
    }());
    HasManyToMany.Accessor = Accessor;
})(HasManyToMany = exports.HasManyToMany || (exports.HasManyToMany = {}));
//# sourceMappingURL=HasManyToMany.js.map