import * as orm from "typeorm";
import { Creator } from "../../typings/Creator";
import { BelongsOneToOne } from "./BelongsOneToOne";
/**
 * Type for a variable using the `Has.OneToOne` decorator.
 *
 * @template Target Type of the target model class who belongs to this model class *Mine* as 1: 1
 * @template Ensure Whether existence of the 1:1 owned record can be assured.
 */
export declare type HasOneToOne<Target extends object, Ensure extends boolean = false> = HasOneToOne.Accessor<Target, Ensure extends true ? Target : Target | null>;
export declare function HasOneToOne<Mine extends object, Target extends object, Ensure extends boolean = false>(targetGen: Creator.Generator<Target>, inverse: (input: Target) => BelongsOneToOne<Mine, any>, ensure?: Ensure): PropertyDecorator;
export declare namespace HasOneToOne {
    class Accessor<Target extends object, Output extends Target | null> {
        private readonly metadata_;
        private readonly mine_;
        private singleton_;
        private constructor();
        statement(): orm.QueryBuilder<Target>;
        set(obj: Output): Promise<void>;
        reload(): Promise<Output>;
        get(): Promise<Output>;
        private _Get;
        private get_null_error_message;
    }
}
