"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initialize = void 0;
var uuid_1 = require("uuid");
var BelongsAccessorBase_1 = require("../decorators/base/BelongsAccessorBase");
var DEFAULT_1 = require("../DEFAULT");
var ITableInfo_1 = require("./internal/ITableInfo");
/**
 * Initialize a model instance.
 *
 * `initailize()` is a global function creating a new model instance very safely.
 *
 * Unlike `TypeORM.Repository.create()` method, who can cause the critical runtime error by
 * ommitting essential variables, the `initialize()` function does nott permit ommitting the
 * essential member variables in the compilation level.
 *
 * In such reason, if you don't ignore error message from the TypeScript compiler, there can't be
 * any runtime error that is caused by the ommitting essential column values in the SQL INSERT or
 * UPDATE level.
 *
 * @template T Type of a model class that is derived from the `Model`
 * @param input Variables that would be assigned to the new model instance
 * @return A new model instance
 */
function initialize(creator, input) {
    var e_1, _a;
    var info = ITableInfo_1.ITableInfo.get(creator);
    var output = new creator();
    try {
        for (var _b = __values(Object.entries(input)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 2), key = _d[0], value = _d[1];
            if (value === DEFAULT_1.DEFAULT)
                continue;
            var type = typeof value;
            if (output[key] instanceof BelongsAccessorBase_1.BelongsAccessorBase) {
                if (value instanceof Object)
                    output[key]._Assign(value);
                else
                    output[key].id = value;
            }
            else if (value === null ||
                type === "boolean" ||
                type === "number" ||
                type === "string" ||
                value instanceof Date)
                output[key] = value;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    if (info.uuid && !output[info.primaryColumn])
        output[info.primaryColumn] = (0, uuid_1.v4)();
    return output;
}
exports.initialize = initialize;
//# sourceMappingURL=initialize.js.map