"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toPrimitive = void 0;
var EncryptedColumn_1 = require("../decorators/EncryptedColumn");
var MapUtil_1 = require("../utils/MapUtil");
var findRepository_1 = require("./findRepository");
function toPrimitive(obj) {
    var e_1, _a, e_2, _b;
    var omitFields = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        omitFields[_i - 1] = arguments[_i];
    }
    var dict = MapUtil_1.MapUtil.take(fk_dicts, obj.constructor, function () {
        var e_3, _a, e_4, _b;
        var dict = new Set();
        var metadata = (0, findRepository_1.findRepository)(obj.constructor).metadata;
        try {
            for (var _c = __values(metadata.foreignKeys), _d = _c.next(); !_d.done; _d = _c.next()) {
                var foreign = _d.value;
                try {
                    for (var _e = (e_4 = void 0, __values(foreign.columns)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var column = _f.value;
                        var property = column.propertyName;
                        dict.add(property);
                    }
                }
                catch (e_4_1) { e_4 = { error: e_4_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                    }
                    finally { if (e_4) throw e_4.error; }
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return dict;
    });
    var output = {};
    try {
        for (var _c = __values(Object.entries(obj)), _d = _c.next(); !_d.done; _d = _c.next()) {
            var _e = __read(_d.value, 2), key = _e[0], value = _e[1];
            if (key[0] === "_")
                if (key.substr(0, ENC_SYMBOL.length) === ENC_SYMBOL) {
                    var property = EncryptedColumn_1.EncryptedColumn.getFieldByIndex(key);
                    output[property] = obj[property];
                }
                else
                    continue;
            else if (key[key.length - 1] === "_")
                continue;
            else if (value instanceof Object)
                if (value instanceof Date)
                    output[key] = value.toString();
                else
                    continue;
            else if (typeof value !== "function" && dict.has(key) === false)
                output[key] = value;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        }
        finally { if (e_1) throw e_1.error; }
    }
    try {
        for (var omitFields_1 = __values(omitFields), omitFields_1_1 = omitFields_1.next(); !omitFields_1_1.done; omitFields_1_1 = omitFields_1.next()) {
            var omit = omitFields_1_1.value;
            delete output[omit];
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (omitFields_1_1 && !omitFields_1_1.done && (_b = omitFields_1.return)) _b.call(omitFields_1);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return output;
}
exports.toPrimitive = toPrimitive;
var fk_dicts = new WeakMap();
var ENC_SYMBOL = "__m_enc_";
//# sourceMappingURL=toPrimitive.js.map