"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InsertCollection = void 0;
var Vector_1 = require("tstl/container/Vector");
var DomainError_1 = require("tstl/exception/DomainError");
var InvalidArgument_1 = require("tstl/exception/InvalidArgument");
var sorting_1 = require("tstl/ranges/algorithm/sorting");
var Mutex_1 = require("tstl/thread/Mutex");
var UniqueLock_1 = require("tstl/thread/UniqueLock");
var Pair_1 = require("tstl/utility/Pair");
var findRepository_1 = require("../functional/findRepository");
var insert_1 = require("../functional/insert");
var ITableInfo_1 = require("../functional/internal/ITableInfo");
var MapUtil_1 = require("../utils/MapUtil");
var InsertCollection = /** @class */ (function () {
    function InsertCollection(limit) {
        if (limit === void 0) { limit = InsertCollection.DEFAULT_LIMIT; }
        this.limit = limit;
        this.dict_ = new Map();
        this.befores_ = new Vector_1.Vector();
        this.afters_ = new Vector_1.Vector();
        this.mutex_ = new Mutex_1.Mutex();
    }
    InsertCollection.prototype.push = function (input, ignore) {
        if (ignore === void 0) { ignore = false; }
        if (input instanceof Array)
            return this._Push(input, ignore);
        else
            return this._Push([input], ignore)[0];
    };
    InsertCollection.prototype.before = function (process) {
        this.befores_.push_back(process);
    };
    InsertCollection.prototype.after = function (process) {
        this.afters_.push_back(process);
    };
    InsertCollection.prototype._Push = function (records, ignore) {
        var e_1, _a;
        if (records.length === 0)
            return records;
        var creator = records[0].constructor;
        var tuple = MapUtil_1.MapUtil.take(this.dict_, creator, function () {
            var info = ITableInfo_1.ITableInfo.get(creator);
            if (info.incremental === true)
                throw new InvalidArgument_1.InvalidArgument("Error on safe.InsertPocket.push(): primary key of the target table is incremental.");
            return new Pair_1.Pair([], ignore);
        }, function (oldbie) {
            if (oldbie.second === false && ignore === true)
                oldbie.second = true;
        });
        try {
            for (var records_1 = __values(records), records_1_1 = records_1.next(); !records_1_1.done; records_1_1 = records_1.next()) {
                var elem = records_1_1.value;
                tuple.first.push(elem);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (records_1_1 && !records_1_1.done && (_a = records_1.return)) _a.call(records_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return records;
    };
    /* -----------------------------------------------------------
        EXECUTE QUERY
    ----------------------------------------------------------- */
    InsertCollection.prototype.execute = function (manager) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._Execute(manager)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    InsertCollection.prototype._Execute = function (manager) {
        return __awaiter(this, void 0, void 0, function () {
            var success;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, UniqueLock_1.UniqueLock.try_lock(this.mutex_, function () { return __awaiter(_this, void 0, void 0, function () {
                            var _a, _b, process_1, e_2_1, _c, _d, tuple, pieces, e_3_1, _e, _f, process_2, e_4_1;
                            var e_2, _g, e_3, _h, e_4, _j;
                            return __generator(this, function (_k) {
                                switch (_k.label) {
                                    case 0:
                                        _k.trys.push([0, 5, 6, 7]);
                                        _a = __values(this.befores_), _b = _a.next();
                                        _k.label = 1;
                                    case 1:
                                        if (!!_b.done) return [3 /*break*/, 4];
                                        process_1 = _b.value;
                                        return [4 /*yield*/, process_1(manager)];
                                    case 2:
                                        _k.sent();
                                        _k.label = 3;
                                    case 3:
                                        _b = _a.next();
                                        return [3 /*break*/, 1];
                                    case 4: return [3 /*break*/, 7];
                                    case 5:
                                        e_2_1 = _k.sent();
                                        e_2 = { error: e_2_1 };
                                        return [3 /*break*/, 7];
                                    case 6:
                                        try {
                                            if (_b && !_b.done && (_g = _a.return)) _g.call(_a);
                                        }
                                        finally { if (e_2) throw e_2.error; }
                                        return [7 /*endfinally*/];
                                    case 7:
                                        _k.trys.push([7, 16, 17, 18]);
                                        _c = __values(this._Get_record_tuples()), _d = _c.next();
                                        _k.label = 8;
                                    case 8:
                                        if (!!_d.done) return [3 /*break*/, 15];
                                        tuple = _d.value;
                                        _k.label = 9;
                                    case 9:
                                        if (!(tuple.first.length !== 0)) return [3 /*break*/, 14];
                                        pieces = tuple.first.splice(0, this.limit);
                                        if (!(manager !== undefined)) return [3 /*break*/, 11];
                                        return [4 /*yield*/, (0, insert_1.insert)(manager, pieces, tuple.second)];
                                    case 10:
                                        _k.sent();
                                        return [3 /*break*/, 13];
                                    case 11: return [4 /*yield*/, (0, insert_1.insert)(pieces, tuple.second)];
                                    case 12:
                                        _k.sent();
                                        _k.label = 13;
                                    case 13: return [3 /*break*/, 9];
                                    case 14:
                                        _d = _c.next();
                                        return [3 /*break*/, 8];
                                    case 15: return [3 /*break*/, 18];
                                    case 16:
                                        e_3_1 = _k.sent();
                                        e_3 = { error: e_3_1 };
                                        return [3 /*break*/, 18];
                                    case 17:
                                        try {
                                            if (_d && !_d.done && (_h = _c.return)) _h.call(_c);
                                        }
                                        finally { if (e_3) throw e_3.error; }
                                        return [7 /*endfinally*/];
                                    case 18:
                                        _k.trys.push([18, 23, 24, 25]);
                                        _e = __values(this.afters_), _f = _e.next();
                                        _k.label = 19;
                                    case 19:
                                        if (!!_f.done) return [3 /*break*/, 22];
                                        process_2 = _f.value;
                                        return [4 /*yield*/, process_2(manager)];
                                    case 20:
                                        _k.sent();
                                        _k.label = 21;
                                    case 21:
                                        _f = _e.next();
                                        return [3 /*break*/, 19];
                                    case 22: return [3 /*break*/, 25];
                                    case 23:
                                        e_4_1 = _k.sent();
                                        e_4 = { error: e_4_1 };
                                        return [3 /*break*/, 25];
                                    case 24:
                                        try {
                                            if (_f && !_f.done && (_j = _e.return)) _j.call(_e);
                                        }
                                        finally { if (e_4) throw e_4.error; }
                                        return [7 /*endfinally*/];
                                    case 25:
                                        this.dict_.clear();
                                        this.befores_.clear();
                                        this.afters_.clear();
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1:
                        success = _a.sent();
                        if (success === false)
                            throw new DomainError_1.DomainError("Error on InsertCollection.execute(): it's already on executing.");
                        return [2 /*return*/];
                }
            });
        });
    };
    InsertCollection.prototype._Get_record_tuples = function () {
        var e_5, _a;
        function compare(x, y) {
            var children = getDependencies(y.first[0].constructor);
            return !children.has(x.first[0].constructor);
        }
        var output = new Vector_1.Vector();
        try {
            for (var _b = __values(this.dict_), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), _ = _d[0], tuple = _d[1];
                output.push_back(tuple);
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_5) throw e_5.error; }
        }
        (0, sorting_1.sort)(output, compare);
        return output.data();
    };
    return InsertCollection;
}());
exports.InsertCollection = InsertCollection;
(function (InsertCollection) {
    /* eslint-disable */
    /**
     * Default piece count for the extended insert query.
     */
    InsertCollection.DEFAULT_LIMIT = 1000;
})(InsertCollection = exports.InsertCollection || (exports.InsertCollection = {}));
exports.InsertCollection = InsertCollection;
function getDependencies(target, connection) {
    if (!connection)
        connection = (0, findRepository_1.findRepository)(target).manager.connection;
    return MapUtil_1.MapUtil.take(dependencies, target, function () {
        var e_6, _a, e_7, _b, e_8, _c;
        var output = new Set();
        try {
            for (var _d = __values(connection.entityMetadatas), _e = _d.next(); !_e.done; _e = _d.next()) {
                var meta = _e.value;
                var child = meta.target;
                if (child === target)
                    continue;
                try {
                    for (var _f = (e_7 = void 0, __values(meta.foreignKeys)), _g = _f.next(); !_g.done; _g = _f.next()) {
                        var foreign = _g.value;
                        if (foreign.referencedEntityMetadata.target === target) {
                            output.add(child);
                            try {
                                for (var _h = (e_8 = void 0, __values(getDependencies(child, connection))), _j = _h.next(); !_j.done; _j = _h.next()) {
                                    var grand = _j.value;
                                    output.add(grand);
                                }
                            }
                            catch (e_8_1) { e_8 = { error: e_8_1 }; }
                            finally {
                                try {
                                    if (_j && !_j.done && (_c = _h.return)) _c.call(_h);
                                }
                                finally { if (e_8) throw e_8.error; }
                            }
                            break;
                        }
                    }
                }
                catch (e_7_1) { e_7 = { error: e_7_1 }; }
                finally {
                    try {
                        if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                    }
                    finally { if (e_7) throw e_7.error; }
                }
            }
        }
        catch (e_6_1) { e_6 = { error: e_6_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
            }
            finally { if (e_6) throw e_6.error; }
        }
        return output;
    });
}
var dependencies = new Map();
//# sourceMappingURL=InsertCollection.js.map